
# The LearningOnline Network with CAPA
# image click response style
#
# $Id: imageresponse.pm,v 1.80 2006/11/06 23:44:42 foxr Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
#FIXME LATER assumes multiple possible submissions but only one is possible 
#currently

package Apache::imageresponse;
use strict;
use Image::Magick();
use Apache::randomlylabel();
use Apache::londefdef();
use Apache::Constants qw(:common :http);
use Apache::lonlocal;
use Apache::lonnet;
use lib '/home/httpd/lib/perl/';
use LONCAPA;
 

BEGIN {
    &Apache::lonxml::register('Apache::imageresponse',('imageresponse'));
}

sub start_imageresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    #when in a radiobutton response use these
    &Apache::lonxml::register('Apache::imageresponse',
			      ('foilgroup','foil','text','image','rectangle',
			       'polygon','conceptgroup'));
    push (@Apache::lonxml::namespace,'imageresponse');
    my $id = &Apache::response::start_response($parstack,$safeeval);
    undef(%Apache::response::foilnames);
    if ($target eq 'meta') {
	$result=&Apache::response::meta_package_write('imageresponse');
    } elsif ($target eq 'analyze') {
	my $part_id="$Apache::inputtags::part.$id";
	push (@{ $Apache::lonhomework::analyze{"parts"} },$part_id);
    }
    return $result;
}

sub end_imageresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;

    pop(@Apache::lonxml::namespace);
    &Apache::lonxml::deregister('Apache::imageresponse',('foilgroup','foil','text','image','rectangle','conceptgroup'));

    my $result;
    if ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    } elsif ($target eq 'tex'
	     && $Apache::lonhomework::type eq 'exam') {
	$result=&Apache::inputtags::exam_score_line($target);
    }

    undef(%Apache::response::foilnames);
    
    if ($target eq 'grade' || $target eq 'web' || $target eq 'answer' || 
	$target eq 'tex' || $target eq 'analyze') {
	&Apache::lonxml::increment_counter(&Apache::response::repetition());
    }
    &Apache::response::end_response();

    return $result;
}

%Apache::response::foilgroup=();
sub start_foilgroup {
    %Apache::response::foilgroup=();
    $Apache::imageresponse::conceptgroup=0;
    &Apache::response::pushrandomnumber();
    return '';
}

sub getfoilcounts {
    my ($parstack,$safeeval)=@_;

    my $max = &Apache::lonxml::get_param('max',$parstack,$safeeval,'-2');
    # +1 since instructors will count from 1
    my $count = $#{ $Apache::response::foilgroup{'names'} }+1;
    #if (&Apache::response::showallfoils()) { $max=$count; }
    return ($count,$max);
}

sub whichfoils {
    my ($max)=@_;
    if (!defined(@{ $Apache::response::foilgroup{'names'} })) { return; }
    my @names = @{ $Apache::response::foilgroup{'names'} };
    my @whichopt =();
    while ((($#whichopt+1) < $max) && ($#names > -1)) {
	&Apache::lonxml::debug("Have $#whichopt max is $max");
	my $aopt;
#	if (&Apache::response::showallfoils()) {
#	    $aopt=0;
#	} else {
	    $aopt=int(&Math::Random::random_uniform() * ($#names+1));
#	}
	&Apache::lonxml::debug("From $#names elms, picking $aopt");
	$aopt=splice(@names,$aopt,1);
	&Apache::lonxml::debug("Picked $aopt");
	push (@whichopt,$aopt);
    }
    return @whichopt;
}

sub prep_image {
    my ($image,$mode,$name)=@_;
    my $part=$Apache::inputtags::part;
    my $respid=$Apache::inputtags::response['-1'];
    my $id=&Apache::loncommon::get_cgi_id();
    my (%x,$i);
    $x{"cgi.$id.BGIMG"}=&escape($image);
    my ($x,$y)=split(/:/,$Apache::lonhomework::history{"resource.$part.$respid.submission"});
    #draws 2 xs on the image at the clicked location
    #one in white and then one in red on top of the one in white
    if (defined($x)    && $x =~/\S/ 
	&& defined($y) && $y =~/\S/ 
	&& !&Apache::response::show_answer()
	&& $mode ne 'answeronly') {
	my $length = 6;
	my $width = 1;
	my $extrawidth = 2;
	my $xmin=($x-$length);
	my $xmax=($x+$length); 
	my $ymin=($y-$length);
	my $ymax=($y+$length);

	$x{"cgi.$id.OBJTYPE"}.='LINE:';
	$i=$x{"cgi.$id.OBJCOUNT"}++;
	$x{"cgi.$id.OBJ$i"}=join(':',(($xmin),($ymin),($xmax),($ymax),
				      "FFFFFF",($width+$extrawidth)));
	$x{"cgi.$id.OBJTYPE"}.='LINE:';
	$i=$x{"cgi.$id.OBJCOUNT"}++;
	$x{"cgi.$id.OBJ$i"}=join(':',(($xmin),($ymax),($xmax),($ymin),
				      "FFFFFF",($width+$extrawidth)));
	$x{"cgi.$id.OBJTYPE"}.='LINE:';
	$i=$x{"cgi.$id.OBJCOUNT"}++;
	$x{"cgi.$id.OBJ$i"}=join(':',(($xmin),($ymin),($xmax),($ymax),
				      "FF0000",($width)));
	$x{"cgi.$id.OBJTYPE"}.='LINE:';
	$i=$x{"cgi.$id.OBJCOUNT"}++;
	$x{"cgi.$id.OBJ$i"}=join(':',(($xmin),($ymax),($xmax),($ymin),
				      "FF0000",($width)));
    }
    if ($mode eq 'answer' || $mode eq 'answeronly') {
	my $width = 1;
	my $extrawidth = 2;
	my @areas = @{ $Apache::response::foilgroup{"$name.area"} };
	foreach my $area (@areas) {
	    if ($area=~/^rectangle:/) {
		$x{"cgi.$id.OBJTYPE"}.='RECTANGLE:';
		$i=$x{"cgi.$id.OBJCOUNT"}++;
		my ($x1,$y1,$x2,$y2)=
		    ($area=~m/rectangle:\(([0-9]+),([0-9]+)\)\-\(([0-9]+),([0-9]+)\)/);
		$x{"cgi.$id.OBJ$i"}=join(':',($x1,$y1,$x2,$y2,"FFFFFF",
					      ($width+$extrawidth)));
		$x{"cgi.$id.OBJTYPE"}.='RECTANGLE:';
		$i=$x{"cgi.$id.OBJCOUNT"}++;
		$x{"cgi.$id.OBJ$i"}=join(':',($x1,$y1,$x2,$y2,"00FF00",$width));
	    } elsif ($area=~/^polygon:(.*)/) {
		$x{"cgi.$id.OBJTYPE"}.='POLYGON:';
		$i=$x{"cgi.$id.OBJCOUNT"}++;
		$x{"cgi.$id.OBJ$i"}=join(':',("FFFFFF",($width+$extrawidth)));
		$x{"cgi.$id.OBJEXTRA$i"}=$1;
		$x{"cgi.$id.OBJTYPE"}.='POLYGON:';
		$i=$x{"cgi.$id.OBJCOUNT"}++;
		$x{"cgi.$id.OBJ$i"}=join(':',("00FF00",$width));
		$x{"cgi.$id.OBJEXTRA$i"}=$1;
	    }
	}
    }
    &Apache::lonnet::appenv(%x);
    return $id;
}

sub displayfoils {
    my ($target,@whichopt) = @_;
    my $result ='';
    my $name;
    my $temp=1;
    foreach $name (@whichopt) {
	$result.=$Apache::response::foilgroup{"$name.text"};
	&Apache::lonxml::debug("Text is $result");
	if ($target eq 'tex') {$result.="\\vskip 0 mm \n";} else {$result.="<br />\n";}
	my $image=$Apache::response::foilgroup{"$name.image"};
	&Apache::lonxml::debug("image is $image");
	if ( $target eq 'web' && $image !~ /^http:/ ) {
	    $image=&clean_up_image($image);
	} 
	&Apache::lonxml::debug("image is $image");
	if ( &Apache::response::show_answer() ) {
	    if ($target eq 'tex') {
		$result.=$Apache::response::foilgroup{"$name.image"}."\\vskip 0 mm \n";
	    } else {
		my $token=&prep_image($image,'answer',$name);
		$result.="<img src=\"/adm/randomlabel.png?token=$token\" /><br />\n";
	    }
	} else {
	    if ($target eq 'tex') {
		$result.=$Apache::response::foilgroup{"$name.image"}."\\vskip 0 mm \n";
	    } else {
		my $id=$Apache::inputtags::response['-1'];
		my $token=&prep_image($image);
		my $temp=1;
		$result.="<input type=\"image\" name=\"HWVAL_$id:$temp\" ".
		    "src=\"/adm/randomlabel.png?token=$token\" /><br />\n";
	    }
	}
	$temp++;
    }
    return $result;
}

sub display_answers {
    my ($target,$whichopt)=@_;

    my $result;
    foreach my $name (@$whichopt) {
	my $image=$Apache::response::foilgroup{"$name.image"};
	&Apache::lonxml::debug("image is $image");
	if ( $target eq 'web' && $image !~ /^http:/ ) {
	    $image = &clean_up_image($image);
	} 
	my $token=&prep_image($image,'answeronly',$name);

	$result.=&Apache::response::answer_header('imageresponse');
	$result.=&Apache::response::answer_part('imageresponse',"<img src=\"/adm/randomlabel.png?token=$token\" /><br />\n");
	$result.=&Apache::response::answer_footer('imageresponse');
    }
    return $result;
}

sub clean_up_image {
    my ($image)=@_;
    if ($image =~ /\s*<img\s*/) {
	($image) = ($image =~ /src\s*=\s*[\"\']([^\"\']+)[\"\']/i);
	if ($image !~ /^http:/) {
	    $image=&Apache::lonnet::hreflocation('',$image);
	}
	if (!$image) {
	    $image='/home/httpd/html/adm/lonKaputt/lonlogo_broken.gif';
	}
    } else {
	$image=&Apache::lonnet::filelocation($Apache::lonxml::pwd[-1],$image);
	&Apache::lonxml::debug("repcopying: $image");
	if (&Apache::lonnet::repcopy($image) ne 'ok') {
	    $image='/home/httpd/html/adm/lonKaputt/lonlogo_broken.gif';
	}
    }
    return $image;
}

sub gradefoils {
    my (@whichopt) = @_;

    my $partid = $Apache::inputtags::part;
    my $id     = $Apache::inputtags::response['-1'];

    if ($Apache::lonhomework::type eq 'exam') {
	&Apache::response::scored_response($partid,$id);
	return;
    }
    
    my $x;
    my $y;
    my $result;
    my $temp=1;
    foreach my $name (@whichopt) {
	$x=$env{"form.HWVAL_$id:$temp.x"};
	$y=$env{"form.HWVAL_$id:$temp.y"};
	&Apache::lonxml::debug("Got a x of $x and a y of $y for $name");
	if (defined($x) && defined($y) &&
	    defined(@{ $Apache::response::foilgroup{"$name.area"} })) {
	    my @areas = @{ $Apache::response::foilgroup{"$name.area"} };
	    my $grade="INCORRECT";
	    foreach my $area (@areas) {
		&Apache::lonxml::debug("Area is $area for $name");
		$area =~ m/([a-z]*):/;
		&Apache::lonxml::debug("Area of type $1");
		if ($1 eq 'rectangle') {
		    $grade=&grade_rectangle($area,$x,$y);
		} elsif ($1 eq 'polygon') {
		    $grade=&grade_polygon($area,$x,$y);
		} else {
		    &Apache::lonxml::error("Unknown area style $area");
		}
		&Apache::lonxml::debug("Area said $grade");
		if ($grade eq 'APPROX_ANS') { last; }
	    }
	    &Apache::lonxml::debug("Foil was $grade");
	    if ($grade eq 'INCORRECT') { $result= 'INCORRECT'; }
	    if (($grade eq 'APPROX_ANS') && ($result ne 'APPROX_ANS')) { $result=$grade; }
	    &Apache::lonxml::debug("Question is $result");
	    $temp++;
	}
    }
    my $responsestr="$x:$y";
    my $part=$Apache::inputtags::part;
    my %previous=&Apache::response::check_for_previous($responsestr,$part,$id);
    if ($result 
	&& $Apache::lonhomework::type eq 'survey') { $result='SUBMITTED'; }
    &Apache::response::handle_previous(\%previous,$result);
    $Apache::lonhomework::results{"resource.$part.$id.submission"}=$responsestr;
    $Apache::lonhomework::results{"resource.$part.$id.awarddetail"}=$result;
    return;
}

sub end_foilgroup {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result='';
    my @whichopt;

    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze' || $target eq 'answer') {

	my ($count,$max) = &getfoilcounts($parstack,$safeeval);
	if ($count>$max) { $count=$max }
	&Apache::lonxml::debug("Count is $count from $max");

	@whichopt = &whichfoils($max);

	if ($target eq 'web' || $target eq 'tex') {
	    $result=&displayfoils($target,@whichopt);
	} elsif ($target eq 'grade') {
	    if ( defined $env{'form.submitted'}) { &gradefoils(@whichopt); }
	} elsif ( $target eq 'analyze') {
	    &Apache::response::analyze_store_foilgroup(\@whichopt,
						      ['text','image','area']);
	} elsif ($target eq 'answer'
		 && $env{'form.answer_output_mode'} ne 'tex') {
	    $result=&display_answers($target,\@whichopt);
	}

    } elsif ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    }
    &Apache::response::poprandomnumber();
    return $result;
}

sub start_conceptgroup {
    $Apache::imageresponse::conceptgroup=1;
    %Apache::response::conceptgroup=();
    return '';
}

sub end_conceptgroup {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    $Apache::imageresponse::conceptgroup=0;
    my $result;
    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze') {
	&Apache::response::pick_foil_for_concept($target,
						 ['area','text','image'],
						 \%Apache::hint::image,
						 $parstack,$safeeval);
    } elsif ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    }
    return $result;
}

sub insert_foil {
    return '
       <foil>
           <image></image>
           <text></text>
           <rectangle></rectangle>
       </foil>
';
}

$Apache::imageresponse::curname='';
sub start_foil {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze' || $target eq 'answer') {
	my $name = &Apache::lonxml::get_param('name',$parstack,$safeeval);
	if ($name eq "") {
	    &Apache::lonxml::warning("Foils without names exist. This can cause problems to malfunction.");
	    $name=$Apache::lonxml::curdepth;
	}
	if (defined($Apache::response::foilnames{$name})) {
	    &Apache::lonxml::error(&mt("Foil name <b><tt>[_1]</tt></b> appears more than once. Foil names need to be unique.",$name));
	}
	$Apache::response::foilnames{$name}++;
	if ( $Apache::imageresponse::conceptgroup
	     #&& !&Apache::response::showallfoils()
	     ) {
	    push(@{ $Apache::response::conceptgroup{'names'} }, $name);
	} else {
	    push(@{ $Apache::response::foilgroup{'names'} }, $name);
	}
	$Apache::imageresponse::curname=$name;
    } elsif ($target eq 'edit') {
	$result  = &Apache::edit::tag_start($target,$token);
	$result .= &Apache::edit::text_arg('Name:','name',$token);
	$result .= &Apache::edit::end_row().
	    &Apache::edit::start_spanning_row();
    } elsif ($target eq 'modified') {
	my $constructtag=&Apache::edit::get_new_args($token,$parstack,
						     $safeeval,'name');
	if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
    } 
    return $result;;
}

sub end_foil {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    }
    return $result;
}

sub start_text {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result='';
    if ($target eq 'web' || $target eq 'tex' || $target eq 'analyze'
	|| $target eq 'answer') { 
	&Apache::lonxml::startredirection; 
    } elsif ($target eq 'edit') {
	my $descr=&Apache::lonxml::get_all_text('/text',$parser,$style);
	$result=&Apache::edit::tag_start($target,$token,'Task Description').
	    &Apache::edit::editfield($token->[1],$descr,'Text',60,2).
	    &Apache::edit::end_row();
    } elsif ($target eq "modified") {
	$result=$token->[4].&Apache::edit::modifiedfield('/text',$parser);
    }
    return $result;
}

sub end_text {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'web' || $target eq 'tex' || $target eq 'analyze'
	|| $target eq 'answer') {
	my $name = $Apache::imageresponse::curname;
	if ( $Apache::imageresponse::conceptgroup
	     #&& !&Apache::response::showallfoils()
	     ) {
	    $Apache::response::conceptgroup{"$name.text"} = &Apache::lonxml::endredirection;
	} else {
	    $Apache::response::foilgroup{"$name.text"} = &Apache::lonxml::endredirection;
	}
    } elsif ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    }
    return $result;
}

sub start_image {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result='';
    if ($target eq 'web' || $target eq 'tex' || $target eq 'analyze'
	|| $target eq 'answer') { 
	&Apache::lonxml::startredirection; 
    } elsif ($target eq 'edit') {
	my $bgimg=&Apache::lonxml::get_all_text('/image',$parser,$style);
	$Apache::edit::bgimgsrc=$bgimg;
	$Apache::edit::bgimgsrcdepth=$Apache::lonxml::curdepth;

	$result=&Apache::edit::tag_start($target,$token,'Clickable Image').
	    &Apache::edit::editline($token->[1],$bgimg,'Image Source File',40);
	$result.=&Apache::edit::browse(undef,'textnode').' ';
	$result.=&Apache::edit::search(undef,'textnode').
	    &Apache::edit::end_row();
    } elsif ($target eq "modified") {
	$result=$token->[4].&Apache::edit::modifiedfield('/image',$parser);
    }
    return $result;
}

sub end_image {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    my $name = $Apache::imageresponse::curname;
    if ($target eq 'web' || $target eq 'answer') {
	my $image = &Apache::lonxml::endredirection();
	&Apache::lonxml::debug("original image is $image");
	if ( $Apache::imageresponse::conceptgroup
	     #&& !&Apache::response::showallfoils()
	     ) {
	    $Apache::response::conceptgroup{"$name.image"} = $image;
	} else {
	    $Apache::response::foilgroup{"$name.image"} = $image;
	}
    } elsif ($target eq 'analyze') {
	my $image = &Apache::lonxml::endredirection();
	if ( $Apache::imageresponse::conceptgroup
	     #&& !&Apache::response::showallfoils()
	     ) {
	    $Apache::response::conceptgroup{"$name.image"} = $image;
	} else {
	    $Apache::response::foilgroup{"$name.image"} = $image;
	}
    } elsif ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    } elsif ($target eq 'tex') {
	my $src = &Apache::lonxml::endredirection();

	#  There may be all sorts of whitespace on fore and aft:

	$src =~ s/\s+$//s;
	$src =~ s/^\s+//s;

	#
	#  Gnuplot e.g. just generates the latex to put inplace.
	#
	my $graphinclude;
	if ($src =~ /^%DYNAMICIMAGE/) {
	    # This is needed because the newline is not always passed -> tex.
	    # At present we don't care about the sizing info.

	    my ($commentline, $restofstuff) = split(/\n/, $src);
	    $graphinclude = $src;
	    $graphinclude =~ s/^$commentline//;
	} else {
	    my ($path,$file) = &Apache::londefdef::get_eps_image($src);
	    my ($height_param,$width_param)=
		&Apache::londefdef::image_size($src,0.3,$parstack,$safeeval);
	    $graphinclude = '\graphicspath{{'.$path.'}}\includegraphics[width='.$width_param.' mm]{'.$file.'}';
	}
	$Apache::response::foilgroup{"$name.image"} ='\vskip 0 mm \noindent '.$graphinclude;
    } 
    return $result;
}

sub start_rectangle {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result='';
    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze' || $target eq 'answer') { 
	&Apache::lonxml::startredirection; 
    } elsif ($target eq 'edit') {
	my $coords=&Apache::lonxml::get_all_text('/rectangle',$parser,$style);
	$result=&Apache::edit::tag_start($target,$token,'Rectangle').
	    &Apache::edit::editline($token->[1],$coords,'Coordinate Pairs',40).
	    &Apache::edit::entercoord(undef,'textnode',undef,undef,'box').
	    &Apache::edit::end_row();
    } elsif ($target eq "modified") {
	&Apache::edit::deletecoorddata();
	$result=$token->[4].&Apache::edit::modifiedfield('/rectangle',$parser);
    }
    return $result;
}

sub grade_rectangle {
    my ($spec,$x,$y) = @_;
    &Apache::lonxml::debug("Spec is $spec");
    my ($x1,$y1,$x2,$y2)=($spec=~m/rectangle:\(([0-9]+),([0-9]+)\)\-\(([0-9]+),([0-9]+)\)/);
    &Apache::lonxml::debug("Point $x1,$y1,$x2,$y2");
    if ($x1 > $x2) { my $temp=$x1;$x1=$x2;$x2=$temp; }
    if ($y1 > $y2) { my $temp=$y1;$y1=$y2;$y2=$temp; }
    if (($x >= $x1) && ($x <= $x2) && ($y >= $y1) && ($y <= $y2)) {
	return 'APPROX_ANS';
    }
    return 'INCORRECT';
}

sub end_rectangle {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze' || $target eq 'answer') {
	my $name = $Apache::imageresponse::curname;
	my $area = &Apache::lonxml::endredirection;
	$area=~s/\s//g;
	&Apache::lonxml::debug("out is $area for $name");
	if ( $Apache::imageresponse::conceptgroup
	     #&& !&Apache::response::showallfoils()
	     ) {
	    push @{ $Apache::response::conceptgroup{"$name.area"} },"rectangle:$area";
	} else {
	    push @{ $Apache::response::foilgroup{"$name.area"} },"rectangle:$area";
	}
    } elsif ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    }
    return $result;
}

sub start_polygon {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result='';
    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze' || $target eq 'answer') { 
	&Apache::lonxml::startredirection; 
    } elsif ($target eq 'edit') {
	my $coords=&Apache::lonxml::get_all_text('/polygon',$parser,$style);
	$result=&Apache::edit::tag_start($target,$token,'Polygon').
	    &Apache::edit::editline($token->[1],$coords,'Coordinate list',40).
	    &Apache::edit::entercoord(undef,'textnode',undef,undef,'polygon').
	    &Apache::edit::end_row();
    } elsif ($target eq "modified") {
	$result=$token->[4].&Apache::edit::modifiedfield('/polygon',$parser);
    }
    return $result;
}

sub grade_polygon {
    my ($spec,$x,$y) = @_;
    &Apache::lonxml::debug("Spec is $spec");
    $spec=~s/^polygon://;
    my @polygon;
    foreach my $coord (split('-',$spec)) {
	my ($x,$y)=($coord=~m/\(([0-9]+),([0-9]+)\)/);
	&Apache::lonxml::debug("x $x y $y");
	push @polygon, {'x'=>$x,'y'=>$y};
    }
    #make end point start point
    push @polygon, $polygon[0];
    # cribbed from
    # http://geometryalgorithms.com/Archive/algorithm_0103/algorithm_0103.htm
    my $crossing = 0;    # the crossing number counter

    # loop through all edges of the polygon
    for (my $i=0; $i<$#polygon; $i++) {    # edge from V[i] to V[i+1]
	if ((($polygon[$i]->{'y'} <= $y)
	     && ($polygon[$i+1]->{'y'} > $y))    # an upward crossing
	    || 
	    (($polygon[$i]->{'y'} > $y) 
	     && ($polygon[$i+1]->{'y'} <= $y))) { # a downward crossing
	    # compute the actual edge-ray intersect x-coordinate
            my $vt = ($y - $polygon[$i]->{'y'}) 
		/ ($polygon[$i+1]->{'y'} - $polygon[$i]->{'y'});
            if ($x < $polygon[$i]->{'x'} + $vt * 
		($polygon[$i+1]->{'x'} - $polygon[$i]->{'x'})) { # x<intersect
                $crossing++;   # a valid crossing of y=P.y right of P.x
	    }
	}
    }

    # 0 if even (out), and 1 if odd (in)
    if ($crossing%2) {
	return 'APPROX_ANS';
    } else {
	return 'INCORRECT';
    }
}

sub end_polygon {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'web' || $target eq 'grade' || $target eq 'tex' ||
	$target eq 'analyze' || $target eq 'answer') {
	my $name = $Apache::imageresponse::curname;
	my $area = &Apache::lonxml::endredirection;
	$area=~s/\s*//g;
	&Apache::lonxml::debug("out is $area for $name");
	if ( $Apache::imageresponse::conceptgroup
	     #&& !&Apache::response::showallfoils()
	     ) {
	    push @{ $Apache::response::conceptgroup{"$name.area"} },"polygon:$area";
	} else {
	    push @{ $Apache::response::foilgroup{"$name.area"} },"polygon:$area";
	}
    } elsif ($target eq 'edit') {
	$result=&Apache::edit::end_table();
    }
    return $result;
}
1;
__END__
 
